package RebuildEntryById::CMS;

use strict;

sub _hdlr_rebuild_entry_by_id {
    my ($cb, $app, $obj, $original) = @_;

    my $plugin = MT->component("RebuildEntryById");
    my $prefix = $plugin->get_config_value('prefix', 'blog:' . $app->blog->id);

    my @tags = $obj->tags;
    foreach my $tag (@tags) {
        (my $rebuild_entry_id = $tag) =~ s/^\@${prefix}(\d+)$/$1/;
        next if $rebuild_entry_id !~ /\d+/;

        my $entry = MT::Entry->load({ id => $rebuild_entry_id });
        return if $obj->id == $entry->id;

        $app->rebuild_entry(
                Entry => $entry,
                BuildDependencies => 0,
                BuildArchives => 0,
                BuildIndexes => 0
        );
    }
}

1;
